#ifdef MAKINGHSUDLL
#define DLLFUNCTION __declspec(dllexport) __stdcall
#else
#define DLLFUNCTION __stdcall
#endif


#include "hsuerror.h"

// HSU Status returned from HsuFunctions
typedef unsigned long	HSU_STATUS;

// Set USB port to the next port after Serial ports etc.
#define USBPORT			MAXPORTS+1
#define HSU_ERR_DLLBAD		1		// Function missing from Ftd2xx.dll
#define HSU_ERR_LOADDLL		1		// Can't Load Ftd2xx.dll

#define TX_HEADER_SIZE				3		// StartCmd(0x3a),cmd char(command),msglength(txcount)
#define RX_HEADER_SIZE				3		// StartCmd(0x3a),cmd char(command),msglength(txcount)

// data structure for relevent HSU port information
// including: port, baud, etc
typedef struct tagHSUINFO
{
	DWORD		dwlength;			
	BYTE		bPort;
	DWORD		dwBaudRate;
	HSU_STATUS	Status;
	FARPROC		HsuErrHandler;
} HSUINFO, *PHSUINFO;

#ifndef MAKINGHSUDLL
typedef HANDLE			HHSU;
#endif

//#ifdef MAKINGHSUDLL
//typedef struct tagHSU
//{
//	int			idHsu;
//	HWND        hWnd;
//	FT_HANDLE	hFtDevice;
//	HINSTANCE	hFtLibrary;
//	HANDLE		idComDev;
//
//	int			BoxNumber;
//	int			Status;
//	FT_STATUS	FtStatus;
//	FARPROC		HsuErrorHandler;
//
//	BOOL		fConnected;
//	BYTE		bPort;
//	BOOL		fDisplayErrors;
//	DWORD		dwBaudRate;
//
//	HANDLE      hPostEvent, hWatchThread, hWatchEvent;	//NU
//	HWND        hTermWnd;								//NU
//	DWORD       dwThreadID;								//NU
//	OVERLAPPED  osWrite, osRead;						//NU
//} HSU, *HHSU;
//#endif

HANDLE DLLFUNCTION HsuOpen(HSUINFO *hsuinfo);

HSU_STATUS DLLFUNCTION HsuClose(HANDLE hHsu);
HSU_STATUS DLLFUNCTION HsuSetErrorHandler(HANDLE hHsu,FARPROC HsuErrorHandler);

HSU_STATUS DLLFUNCTION HsuReadVersion(HANDLE hHsu,int BoxNumber,int ResetErr,short *Version,short *ErrFlags,short *ErrMask);

HSU_STATUS DLLFUNCTION HsuReadOneProbe(HANDLE hHsu,int BoxNumber,int ProbeNumber,short *Result);
HSU_STATUS DLLFUNCTION HsuReadAllInputs(HANDLE hHsu,int BoxNumber,short *ResultArray);
HSU_STATUS DLLFUNCTION HsuReadAllProbes(HANDLE hHsu,int BoxNumber,short *ResultArray);

HSU_STATUS DLLFUNCTION HsuSetGain(HANDLE hHsu,int BoxNumber,int ProbeNumber,int Ri,int Rf);
HSU_STATUS DLLFUNCTION HsuReadGain(HANDLE hHsu,int BoxNumber,int ProbeNumber,int *Ri,int *Rf);
HSU_STATUS DLLFUNCTION HsuStoreGain(HANDLE hHsu,int BoxNumber,int ProbeNumber);

HSU_STATUS DLLFUNCTION HsuSetFrequency(HANDLE hHsu,int BoxNumber,int Frequency);
HSU_STATUS DLLFUNCTION HsuReadFrequency(HANDLE hHsu,int BoxNumber,int *Frequency);
HSU_STATUS DLLFUNCTION HsuStoreFrequency(HANDLE hHsu,int BoxNumber,int Frequency);
HSU_STATUS DLLFUNCTION HsuReadKDDS(HANDLE hHsu,int BoxNumber,ULONG *KDDS);

HSU_STATUS DLLFUNCTION HsuSetAverage(HANDLE hHsu,int BoxNumber,int Average);
HSU_STATUS DLLFUNCTION HsuReadAverage(HANDLE hHsu,int BoxNumber,int *Average);
HSU_STATUS DLLFUNCTION HsuStoreAverage(HANDLE hHsu,int BoxNumber,int Average);

HSU_STATUS DLLFUNCTION HsuReadAdjust(HANDLE hHsu,int BoxNumber,int ProbeNumber,
															 int *Zero,int *Mult,float *Fsv);
HSU_STATUS DLLFUNCTION HsuStoreAdjust(HANDLE hHsu,int BoxNumber,int ProbeNumber,
															 int Zero,int Mult,float Fsv);


